.386

.model flat, stdcall 
option casemap :none 

	include \MASM32\INCLUDE\windows.inc
	include \MASM32\INCLUDE\user32.inc
	include \MASM32\INCLUDE\kernel32.inc
	include \MASM32\INCLUDE\setupapi.inc

	includelib \MASM32\LIB\user32.lib
	includelib \MASM32\LIB\kernel32.lib
	includelib \masm32\LIB\setupapi.lib

_GUIDX STRUCT
  Data1			DWORD ?
  Data2			WORD ?
  Data3			WORD ?
  Data4			byte 8 dup(?)           
_GUIDX ends

_SP_DEVINFO_DATA struct
  cbSize		DWORD ?
  ClassGuid		_GUID <>
  DevInst		DWORD ?
  Reserved		DWORD ?
_SP_DEVINFO_DATA ends

_SP_DEVICE_INTERFACE_DATA STRUCT
  cbSize		DWORD ?
  InterfaceClassGuid	_GUID <>
  Flags			DWORD ?
  Reserved		DWORD ?
_SP_DEVICE_INTERFACE_DATA ends

_SP_DEVICE_INTERFACE_DETAIL_DATA STRUCT
  cbSize		DWORD ?
  DevicePath		db 1 dup(?)	;[ANYSIZE_ARRAY]
_SP_DEVICE_INTERFACE_DETAIL_DATA ends

.const
DIGCF_PRESENT		equ 00000002h
DIGCF_ALLCLASSES	equ 00000004h
DIGCF_PROFILE		equ 00000008h
DIGCF_DEVICEINTERFACE	equ 00000010h
SPDRP_HARDWAREID	equ 00000001h
SPDRP_COMPATIBLEIDS	equ 00000002h
SPDRP_CLASSGUID		equ 00000008h
USBGUID			_GUIDX <0A5DCBF10h, 06530h, 011D2h, <090h, 01Fh, 000h, 0C0h, 04Fh, 0B9h, 051h, 0EDh>>
DISKGUID		_GUIDX <053f56307h, 0b6bfh, 011d0h, <94h , 0f2h, 000h, 0a0h, 0c9h, 01eh, 0fbh, 08bh>>
VOLUMEGUID		_GUIDX <053f5630dh, 0b6bfh, 011d0h, <94h , 0f2h, 000h, 0a0h, 0c9h, 01eh, 0fbh, 08bh>>

.data
form			db "ERROR: %u", 0
perenos			db 13,10,0

.data?
buffer			db 512 dup(?)
string			db 1024 dup(?)
Devinfo			_SP_DEVINFO_DATA <>
Interface		_SP_DEVICE_INTERFACE_DATA <>
InterfaceDetailed	_SP_DEVICE_INTERFACE_DETAIL_DATA <>
			db 512 dup(?)	;
cw			dd ?

.code
start:
invoke SetupDiGetClassDevs,addr DISKGUID,0,0,DIGCF_PRESENT OR DIGCF_DEVICEINTERFACE
.if eax !=INVALID_HANDLE_VALUE
	mov ebx, eax
	xor esi, esi
	mov Devinfo.cbSize, sizeof _SP_DEVINFO_DATA
@@:
	invoke SetupDiEnumDeviceInfo, ebx, esi, addr Devinfo
	.if eax==TRUE
		invoke SetupDiGetDeviceRegistryProperty, ebx, addr Devinfo, SPDRP_HARDWAREID, NULL, addr buffer, sizeof buffer, addr cw
		invoke lstrcat, addr string, addr buffer
		invoke lstrcat, addr string, addr perenos

		mov Interface.cbSize, sizeof Interface
		xor edi, edi
	NEXT:
		invoke SetupDiEnumDeviceInterfaces, ebx, NULL, addr DISKGUID, edi, addr Interface
		.if eax == TRUE
			invoke SetupDiGetDeviceInterfaceDetail, ebx, addr Interface, NULL, NULL, addr cw, NULL
				mov InterfaceDetailed.cbSize, sizeof _SP_DEVICE_INTERFACE_DETAIL_DATA
				invoke SetupDiGetDeviceInterfaceDetail, ebx, addr Interface, addr InterfaceDetailed, cw, addr cw, NULL
				.if eax == TRUE
					invoke lstrcat, addr string, addr InterfaceDetailed.DevicePath
					invoke lstrcat, addr string, addr perenos
				.endif
				add edi, 1
				jmp NEXT
		.endif
		add esi, 1
		jmp @B
	.endif
	invoke SetupDiDestroyDeviceInfoList, ebx
	invoke MessageBox,0,ADDR string,0,MB_ICONASTERISK
.else
	invoke GetLastError
	invoke wsprintf,ADDR buffer,ADDR form,eax
	invoke MessageBox,0,ADDR buffer,0,MB_ICONASTERISK
.endif
invoke ExitProcess,0
end start